// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// Simple program to test graph construction:
// Reads graph from a file and builds it.
// Use any of the files in this directory with a .gph extension.
// This version is for the Adjancency Matrix representation

#include "book.h"

// Include the graph classes -- Adjacency Matrix
#include "grmat.h"

int main()
{
    Graph *G;
    FILE *fid;

    fid = fopen("bkexamp.gph", "rt");
    G = createGraph<Graphm>(fid);
    Gprint(G);

    return 0;
}
