// Easy graph main.
#include "book.h"

// Include the graph classes -- Adjacency Matrix
#include "grmat.h"
#include "grlist.h"

int main()
{
    Graph *Gtest[2];

    // First loop is adjacency matrix,
    // and second loop is adjacency list.
    for(int i = 0; i < 2; i++)
    {
        if(i == 0)
            Gtest[0] = new Graphm(6);
        if(i == 1)
            Gtest[1] = new Graphl(6);
        
        cout << "Adding edges:" << endl;
        Gtest[i]->setEdge(3, 2, 1);
        Gtest[i]->setEdge(2, 4, 3);
        Gtest[i]->setEdge(3, 1, 2);
        Gtest[i]->setEdge(5, 2, 8);

        Gprint(Gtest[i]);

        Gtest[i]->weight(5, 2);
        Gtest[i]->isEdge(5, 2);

        Gtest[i]->delEdge(5, 2);

        Gtest[i]->weight(5, 2);
        Gtest[i]->isEdge(5, 2);

        Gtest[i]->first(3);
        Gtest[i]->next(3, Gtest[i]->first(3));
    }

    return 0;
}
